import { ThreeBufferGeometry } from '@angular-three/core/geometries';
import { NgZone, OnChanges, OnInit } from '@angular/core';
import type { BuiltinShaderAttributeName } from 'three';
import { BufferAttribute } from 'three';
export declare abstract class ThreeAttribute<TAttribute extends BufferAttribute = BufferAttribute, TAttributeConstructor extends typeof BufferAttribute = typeof BufferAttribute> implements OnInit, OnChanges {
    protected readonly ngZone: NgZone;
    protected readonly geometryDirective?: ThreeBufferGeometry<import("three").BufferGeometry, typeof import("three").BufferGeometry> | undefined;
    attach?: BuiltinShaderAttributeName;
    abstract attributeType: TAttributeConstructor;
    constructor(ngZone: NgZone, geometryDirective?: ThreeBufferGeometry<import("three").BufferGeometry, typeof import("three").BufferGeometry> | undefined);
    private _extraArgs;
    protected set extraArgs(v: unknown[]);
    private _attribute;
    ngOnChanges(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    get attribute(): TAttribute;
}
