import { InstancesStore } from '@angular-three/core';
import { Directive, Input, SkipSelf } from '@angular/core';
export class ThreeBufferGeometry {
    constructor(instancesStore) {
        this.instancesStore = instancesStore;
        this._extraArgs = [];
    }
    set extraArgs(v) {
        this._extraArgs = v;
    }
    get bufferGeometry() {
        if (!this._bufferGeometry) {
            const args = this._extraArgs;
            this._bufferGeometry = new this.geometryType(...args);
            this.instancesStore.saveBufferGeometry({
                id: this.ngtId,
                bufferGeometry: this._bufferGeometry,
            });
        }
        return this._bufferGeometry;
    }
}
ThreeBufferGeometry.decorators = [
    { type: Directive }
];
ThreeBufferGeometry.ctorParameters = () => [
    { type: InstancesStore, decorators: [{ type: SkipSelf }] }
];
ThreeBufferGeometry.propDecorators = {
    ngtId: [{ type: Input }]
};
//# sourceMappingURL=geometry.abstract.js.map