import { ThreeObject3d } from '@angular-three/core';
import { ThreeBufferGeometry } from '@angular-three/core/geometries';
import { ThreeMaterial } from '@angular-three/core/materials';
import { ContentChild, Directive, Input, } from '@angular/core';
import { BufferGeometry, Material } from 'three';
export class ThreeMesh extends ThreeObject3d {
    set extraArgs(v) {
        this._extraArgs = v;
    }
    ngAfterContentInit() {
        this.init();
    }
    initObject() {
        var _a, _b;
        if (this.canCreate()) {
            let geometry = (_a = this.bufferGeometryDirective) === null || _a === void 0 ? void 0 : _a.bufferGeometry;
            let material = (_b = this.materialDirective) === null || _b === void 0 ? void 0 : _b.material;
            if (this.geometry) {
                if (this.geometry instanceof BufferGeometry) {
                    geometry = this.geometry;
                }
                else {
                    geometry = this.instancesStore.getImperativeState().bufferGeometries[this.geometry];
                }
            }
            if (this.material) {
                if (this.material instanceof Material) {
                    material = this.material;
                }
                else {
                    material = this.instancesStore.getImperativeState().materials[this.material];
                }
            }
            this._mesh = new this.meshType(geometry, material, ...(this._extraArgs || []));
            if (this.morphTargetDictionary) {
                this._mesh.morphTargetDictionary = this.morphTargetDictionary;
            }
            if (this.morphTargetInfluences) {
                this._mesh.morphTargetInfluences = this.morphTargetInfluences;
            }
            if (this.customize) {
                this.customize();
            }
        }
    }
    canCreate() {
        return true;
    }
    get object3d() {
        return this._mesh;
    }
}
ThreeMesh.decorators = [
    { type: Directive }
];
ThreeMesh.propDecorators = {
    geometry: [{ type: Input }],
    material: [{ type: Input }],
    morphTargetInfluences: [{ type: Input }],
    morphTargetDictionary: [{ type: Input }],
    materialDirective: [{ type: ContentChild, args: [ThreeMaterial,] }],
    bufferGeometryDirective: [{ type: ContentChild, args: [ThreeBufferGeometry,] }]
};
//# sourceMappingURL=mesh.abstract.js.map